/*
	File:		USB_DriverDescription.c

	Contains:	The require DriverDescription structure for 'ndrv's

	Version:	1.0

	Copyright:	 1999 by Apple Computer, Inc., all rights reserved.
*/

#include "NativeDriverDesciption.h"
#include "StorageDeviceConfiguration.h"
#include "USB_Version.h"

//----------------------------------------------------------------------------------
//	The Driver Description structure -
// 	This structure provides the Device Manager with information about our native driver
//----------------------------------------------------------------------------------
DriverDescription TheDriverDescription = 
{
	kTheDescriptionSignature,
	kInitialDriverDescriptor,

	// DriverType
	kDriverNameString,
	kStorageHexMajorVers, kStorageHexMinorVers, kStorageReleaseStage, kStorageCurrentRelease,

	// DriverOSRuntimeInfo
	0
	| (1 * kDriverIsLoadedUponDiscovery)	//	Loader runtime options
	| (1 * kDriverIsOpenedUponLoad)			//	Opened when loaded
	| (0 * kDriverIsUnderExpertControl)		//	No I/O expert to handle loads/opens
	| (0 * kDriverIsConcurrent)				//	Not concurrent yet
	| (0 * kDriverQueuesIOPB),				//	Not internally queued yet
	kDriverNameString,						//	Str31 driverName (OpenDriver param)
	0, 0, 0, 0, 0, 0, 0, 0,					//	UInt32 driverDescReserved[8]

	// DriverOSService
	1,										//	Service Count

	// DriverServiceInfo
	kServiceCategoryNdrvDriver,				//	OSType serviceCategory
	kNdrvTypeIsGeneric,						//	OSType serviceType
	1, 0, finalStage, 0						// 	Service version number
};

