/*
	File:		UnitTableDoDriverIO.h

	Contains:	This file contains the sole entry point into the driver
				from the system, and the sole return command completion point.

	Version:	1.0

	Copyright:	 1998-1999 by Apple Computer, Inc., all rights reserved.

*/

#pragma once

#include <DriverServices.h>

//------------------------------------------------------------------------------
//	Debugging Macros-
//	This will turn DebugStr's on and off throughout the driver
//----------------------------------------------------------------------------------
#ifndef Include_Debugging
	#define Include_Debugging 0			// Set to 1 to enable debugging
#endif

#if Include_Debugging
	#define IfDebugging(str)	SysDebugStr(str)
#else
	#define IfDebugging(str)
#endif

//----------------------------------------------------------------------------------
//	The DoDriverIO Function -
// 	This function is the only entry to our driver from the Device Manager
//----------------------------------------------------------------------------------

extern OSStatus DoDriverIO(	AddressSpaceID		addressSpaceID,
							IOCommandID			ioCommandID,
							IOCommandContents	ioCommandContents,
							IOCommandCode		ioCommandCode,
							IOCommandKind		ioCommandKind );



extern OSStatus FinishCommandProcessing( 	IOCommandID ioCommandID,
											OSStatus incomingStatus );
