/*
	File:		UnitTableReadWriteSupport.h

	Contains:	Handles read and write requests.  Also handles all filesystem
				to device block conversions.

	Version:	1.0

	Copyright:	 1999 by Apple Computer, Inc., all rights reserved.

*/

#pragma once

#include "UnitTableDeviceAccess.h"

typedef CALLBACK_API_C( void , ReadWriteCompletionProcPtr )( UInt32 userData, OSStatus status );

extern OSStatus DoReadWriteCommand(	UInt32 						userData, 
									IOParamPtr					iopb,
									UInt16						driveNum,
									Boolean						doWrite, 
									ReadWriteCompletionProcPtr	callback);

extern OSStatus DoReadWritePhysicalBlocks ( UInt32					userData,
									UInt32							startBlock,
									UInt32							blockCount,
									UInt32							blockSize,
									Boolean							convertToSystemBlocks,
									Ptr								buffer,
									UInt32							byteCount,
									Boolean							doWrite,
									ReadWriteCompletionProcPtr		callBack);
