#
#	File:		UniversalModule.make
#
#	Contains:	Make for for USB Universal HID module
#
#	Version:	xxx put version here xxx
#
#	Copyright:	 1997-1998 by Apple Computer, Inc., all rights reserved.
#
MAKEFILE     = UniversalModule.make
MondoBuild = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
Includes     = -i {USBInterfacesInternal},{USBInterfacesExternal}
SymPPC      = -sym on 
UniversalModuleTarget	= {USBTargets}Drivers:USBHIDSampleUniversModule

PPCCOptions  = {Includes} {SymPPC}    {NeptuneCOptions}

LinkPPC		=	PPCLink

ObjectsPPC	=	"{USBObjects}UniversalModule.c.o"			
				"{USBObjects}UniversalModuleHeader.c.o" 		
				"{USBObjects}UniversalHIDAPI.c.o"		

UniversalModule  "{USBReleaseExtensions}USBHIDSampleUniversModule"  

"{USBReleaseExtensions}USBHIDSampleUniversModule"   "{UniversalModuleTarget}" 
		duplicate -y "{UniversalModuleTarget}"  {Targ}
		
{UniversalModuleTarget}		{MondoBuild}  {ObjectsPPC}	 "{USBInterfacesInternal}USBHIDModule.exp"
	delete -i "{Targ}.xcoff"
	delete -i "{Targ}.dbg"
	{LinkPPC}												
		-map "{USBMapDir}USBHIDSampleUniversModule.map"	
		-t 'ndrv'											
		-c 'usbd'											
		-o {UniversalModuleTarget} {SymPPC} 				
		{ObjectsPPC} 										
		-xm sharedlibrary									
		-share context										
		-@export "{USBInterfacesInternal}UniversalHIDModule.exp"	
		"{USBLibraries}USBServicesLib" 						
		"{SharedLibraries}InterfaceLib" 					
		"{SharedLibraries}NameRegistryLib"					
		"{SharedLibraries}DriverLoaderLib"					
		"{SharedLibraries}DriverServicesLib" 				
		"{PPCLibraries}PPCCRuntime.o"


{UniversalModuleTarget}		"{USBInterfacesInternal}PackageVersion.h"	
						"UniversalModuleVersion.h"						
						"UniversalModule.r"								
						{MondoBuild}
	Rez														
		-i "{USBInterfacesInternal}"						
		-i "{RIncludes}"									
		"{RIncludes}Types.r"								
		"UniversalModule.r"									
		-a													
		-o {Targ}
		
"{USBObjects}UniversalModuleHeader.c.o"		"UniversalModuleHeader.c"			
										"{USBInterfacesExternal}USB.h"			
										"{USBInterfacesInternal}PackageVersion.h" 
										"UniversalModuleVersion.h"				
										"UniversalModule.h"						
	{PPCC} UniversalModuleHeader.c -o {Targ} {PPCCOptions}

"{USBObjects}UniversalModule.c.o"		"UniversalModule.c"				
										"{USBInterfacesExternal}USB.h"	
										"{USBInterfacesInternal}UniversalHIDModule.h"			
										"UniversalModule.h"
	{PPCC} UniversalModule.c -o {Targ} {PPCCOptions}

"{USBObjects}UniversalHIDAPI.c.o"		"UniversalHIDAPI.c"				
									"{USBInterfacesExternal}USB.h"		
									"{USBInterfacesInternal}UniversalHIDModule.h"				
									"UniversalModule.h"
	{PPCC} UniversalHIDAPI.c -o {Targ} {PPCCOptions}

"{USBObjects}UniversalConfigParse.c.o"		"UniversalConfigParse.c"	
										"{USBInterfacesExternal}USB.h"	
										"UniversalModule.h"						
	{PPCC} UniversalConfigParse.c -o {Targ} {PPCCOptions}

Clean 
	Delete -i {ObjectsPPC}
	Delete -i {UniversalModuleTarget} 
	Delete -i "{USBReleaseExtensions}USBHIDSampleUniversModule"
